#!/usr/bin/env -S python ../../tools/MakeMenu.py -o EightChannelDemoMenu.h # NB: must be run in the sketch directory    >NUL 2>NUL
@python "%~dp0..\..\tools\MakeMenu.py" -o "%~dp0EightChannelDemoMenu.h" "%~f0"
@exit /b %ERRORLEVEL%

# $BEGIN_SYNCGENIE_LICENSE$
# 
# This file is part of the SyncGenie project, a library for the Arduino IDE
# for interfacing with the the Teensy microcontroller via a SyncGenie
# breakout board (see https://osf.io/r9pb6/ ), with an emphasis on time
# synchronization in neuroscience experiments.
# 
# Author: Jeremy Hill (2024-)
# 
# No Copyright
# ============
# The author has dedicated this work to the public domain under the terms of
# Creative Commons' CC0 1.0 Universal legal code, waiving all of his rights to
# the work worldwide under copyright law, including all related and neighboring
# rights, to the extent allowed by law.
# 
# You can copy, modify, distribute and perform the work, even for commercial
# purposes, all without asking permission. See Other Information below.
# 
# Other Information
# =================
# In no way are the patent or trademark rights of any person affected by CC0,
# nor are the rights that other persons may have in the work or in how the work
# is used, such as publicity or privacy rights.
# 
# The author makes no warranties about the work, and disclaims liability for
# all uses of the work, to the fullest extent permitted by applicable law. When
# using or citing the work, you are requested to preserve the author attribution
# and this copyright waiver, but you should not imply endorsement by the author.
# 
# $END_SYNCGENIE_LICENSE$

/Help (click SEL)                                              @select: genie.loadMessage(MAIN_DOC); return false;
/Help (click SEL)/x                                            @render: genie.showMessage();  @left: genie.scrollMessage(-1); return false;  @right: genie.scrollMessage(+1); return true;  @select: return true;

/Configure TRS1                                                @visible: gVisibleInMenu[TRS1]
/Configure TRS1/TRS1 Mode/AC TRIGGER                           @select:  ConfigureTRS(TRS1, AC_TRIGGER);   @selected: (gJackModes[TRS1] == AC_TRIGGER)
/Configure TRS1/TRS1 Mode/DC TRIGGER                           @select:  ConfigureTRS(TRS1, DC_TRIGGER);   @selected: (gJackModes[TRS1] == DC_TRIGGER)
/Configure TRS1/TRS1 Mode/SWITCH                               @select:  ConfigureTRS(TRS1, SWITCH    );   @selected: (gJackModes[TRS1] == SWITCH    )
/Configure TRS1/TRS1 Mode/NO PROCESSING                        @select:  ConfigureTRS(TRS1, DISABLED  );   @selected: (gJackModes[TRS1] == DISABLED  )
#/Configure TRS1/TRS1 Sample Rate/x                             @visible   (gJackModes[TRS1] == DC_TRIGGER || gJackModes[TRS1] == AC_TRIGGER)  @left: return AdjustSampleRate(-1, TRS1, modifyNavigation); @right: return AdjustSampleRate(+1, TRS1, modifyNavigation); @render: RenderSampleRate(TRS1);
/Configure TRS1/TRS1 Circuit                                   @visible:  (gJackModes[TRS1] != DISABLED)
/Configure TRS1/TRS1 Circuit/READ TIP & RING                   @visible:  (gJackModes[TRS1] != DISABLED)  @select: ConfigureTRS(TRS1, KEEP_MODE, READ_BOTH       );  @selected: (gCircuitTypes[TRS1] == READ_BOTH       )
/Configure TRS1/TRS1 Circuit/TIP LO READ RING                  @visible:  (gJackModes[TRS1] != DISABLED)  @select: ConfigureTRS(TRS1, KEEP_MODE, TIP_LO_READ_RING);  @selected: (gCircuitTypes[TRS1] == TIP_LO_READ_RING)
/Configure TRS1/TRS1 Circuit/RING LO READ TIP                  @visible:  (gJackModes[TRS1] != DISABLED)  @select: ConfigureTRS(TRS1, KEEP_MODE, RING_LO_READ_TIP);  @selected: (gCircuitTypes[TRS1] == RING_LO_READ_TIP)
/Configure TRS1/TRS1 Circuit/TIP HI READ RING                  @visible:  (gJackModes[TRS1] != DISABLED)  @select: ConfigureTRS(TRS1, KEEP_MODE, TIP_HI_READ_RING);  @selected: (gCircuitTypes[TRS1] == TIP_HI_READ_RING)
/Configure TRS1/TRS1 Circuit/RING HI READ TIP                  @visible:  (gJackModes[TRS1] != DISABLED)  @select: ConfigureTRS(TRS1, KEEP_MODE, RING_HI_READ_TIP);  @selected: (gCircuitTypes[TRS1] == RING_HI_READ_TIP)
/Configure TRS1/TRS1 Tip (T1)                                  @visible: (gChannelModes[T1] != DISABLED && gCircuitTypes[TRS1] != TIP_LO_READ_RING && gCircuitTypes[TRS1] != TIP_HI_READ_RING)
/Configure TRS1/TRS1 Tip (T1)/T1 Threshold/x                   @visible: (gChannelModes[T1] == DC_TRIGGER || gChannelModes[T1] == AC_TRIGGER)   @render: RenderThreshold(T1);  @left: return AdjustThreshold(-1, T1, modifyNavigation);  @right: return AdjustThreshold(+1, T1, modifyNavigation);
/Configure TRS1/TRS1 Tip (T1)/T1 Minimum ms/x                  @visible: (gChannelModes[T1] == DC_TRIGGER || gChannelModes[T1] == AC_TRIGGER)   @render: RenderMinLength(T1);  @left: return AdjustMinLength(-1, T1, modifyNavigation);  @right: return AdjustMinLength(+1, T1, modifyNavigation);
/Configure TRS1/TRS1 Tip (T1)/T1 Increment ms/x                @visible: (gChannelModes[T1] == DC_TRIGGER || gChannelModes[T1] == AC_TRIGGER)   @render: RenderIncrement(T1);  @left: return AdjustIncrement(-1, T1, modifyNavigation);  @right: return AdjustIncrement(+1, T1, modifyNavigation);
/Configure TRS1/TRS1 Tip (T1)/T1 Refractory ms/x               @visible: (gChannelModes[T1] == DC_TRIGGER || gChannelModes[T1] == AC_TRIGGER)   @render: RenderRefractMs(T1);  @left: return AdjustRefractMs(-1, T1, modifyNavigation);  @right: return AdjustRefractMs(+1, T1, modifyNavigation);
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D0_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D0_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D0_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D1_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D1_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D1_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D2_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D2_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D2_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D3_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D3_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D3_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D4_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D4_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D4_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D5_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D5_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D5_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D6_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D6_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D6_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D7_OUT            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D7_OUT; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D7_OUT)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D8_LED            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D8_LED; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D8_LED)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/D9_LED            @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.D9_LED; InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.D9_LED)
/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/NO D-SUB PIN      @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = NO_PIN;       InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == NO_PIN      )
#/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/BNC1              @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.BNC1;   InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.BNC1  )
#/Configure TRS1/TRS1 Tip (T1)/T1 Main Output/BNC2              @visible: (gChannelModes[T1] != DISABLED)   @select: gOutput1Pins[T1] = genie.BNC2;   InitializeOutputPins(T1);  @selected: (gOutput1Pins[T1] == genie.BNC2  )
/Configure TRS1/TRS1 Ring (R1)                                 @visible: (gChannelModes[R1] != DISABLED && gCircuitTypes[TRS1] != RING_LO_READ_TIP && gCircuitTypes[TRS1] != RING_HI_READ_TIP)
/Configure TRS1/TRS1 Ring (R1)/R1 Threshold/x                  @visible: (gChannelModes[R1] == DC_TRIGGER || gChannelModes[R1] == AC_TRIGGER)   @render: RenderThreshold(R1);  @left: return AdjustThreshold(-1, R1, modifyNavigation);  @right: return AdjustThreshold(+1, R1, modifyNavigation);
/Configure TRS1/TRS1 Ring (R1)/R1 Minimum ms/x                 @visible: (gChannelModes[R1] == DC_TRIGGER || gChannelModes[R1] == AC_TRIGGER)   @render: RenderMinLength(R1);  @left: return AdjustMinLength(-1, R1, modifyNavigation);  @right: return AdjustMinLength(+1, R1, modifyNavigation);
/Configure TRS1/TRS1 Ring (R1)/R1 Increment ms/x               @visible: (gChannelModes[R1] == DC_TRIGGER || gChannelModes[R1] == AC_TRIGGER)   @render: RenderIncrement(R1);  @left: return AdjustIncrement(-1, R1, modifyNavigation);  @right: return AdjustIncrement(+1, R1, modifyNavigation);
/Configure TRS1/TRS1 Ring (R1)/R1 Refractory ms/x              @visible: (gChannelModes[R1] == DC_TRIGGER || gChannelModes[R1] == AC_TRIGGER)   @render: RenderRefractMs(R1);  @left: return AdjustRefractMs(-1, R1, modifyNavigation);  @right: return AdjustRefractMs(+1, R1, modifyNavigation);
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D0_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D0_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D0_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D1_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D1_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D1_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D2_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D2_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D2_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D3_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D3_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D3_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D4_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D4_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D4_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D5_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D5_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D5_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D6_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D6_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D6_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D7_OUT           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D7_OUT; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D7_OUT)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D8_LED           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D8_LED; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D8_LED)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/D9_LED           @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.D9_LED; InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.D9_LED)
/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/NO D-SUB PIN     @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = NO_PIN;       InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == NO_PIN      )
#/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/BNC1             @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.BNC1;   InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.BNC1  )
#/Configure TRS1/TRS1 Ring (R1)/R1 Main Output/BNC2             @visible: (gChannelModes[R1] != DISABLED)   @select: gOutput1Pins[R1] = genie.BNC2;   InitializeOutputPins(R1);  @selected: (gOutput1Pins[R1] == genie.BNC2  )

/Configure TRS2                                                @visible: gVisibleInMenu[TRS2]
/Configure TRS2/TRS2 Mode/AC TRIGGER                           @select:  ConfigureTRS(TRS2, AC_TRIGGER);   @selected: (gJackModes[TRS2] == AC_TRIGGER)
/Configure TRS2/TRS2 Mode/DC TRIGGER                           @select:  ConfigureTRS(TRS2, DC_TRIGGER);   @selected: (gJackModes[TRS2] == DC_TRIGGER)
/Configure TRS2/TRS2 Mode/SWITCH                               @select:  ConfigureTRS(TRS2, SWITCH    );   @selected: (gJackModes[TRS2] == SWITCH    )
/Configure TRS2/TRS2 Mode/NO PROCESSING                        @select:  ConfigureTRS(TRS2, DISABLED  );   @selected: (gJackModes[TRS2] == DISABLED  )
#/Configure TRS2/TRS2 Sample Rate/x                             @visible   (gJackModes[TRS2] == DC_TRIGGER || gJackModes[TRS2] == AC_TRIGGER)  @left: return AdjustSampleRate(-1, TRS2, modifyNavigation); @right: return AdjustSampleRate(+1, TRS2, modifyNavigation); @render: RenderSampleRate(TRS2);
/Configure TRS2/TRS2 Circuit                                   @visible:  (gJackModes[TRS2] != DISABLED)
/Configure TRS2/TRS2 Circuit/READ TIP & RING                   @visible:  (gJackModes[TRS2] != DISABLED)  @select: ConfigureTRS(TRS2, KEEP_MODE, READ_BOTH       );  @selected: (gCircuitTypes[TRS2] == READ_BOTH       )
/Configure TRS2/TRS2 Circuit/TIP LO READ RING                  @visible:  (gJackModes[TRS2] != DISABLED)  @select: ConfigureTRS(TRS2, KEEP_MODE, TIP_LO_READ_RING);  @selected: (gCircuitTypes[TRS2] == TIP_LO_READ_RING)
/Configure TRS2/TRS2 Circuit/RING LO READ TIP                  @visible:  (gJackModes[TRS2] != DISABLED)  @select: ConfigureTRS(TRS2, KEEP_MODE, RING_LO_READ_TIP);  @selected: (gCircuitTypes[TRS2] == RING_LO_READ_TIP)
/Configure TRS2/TRS2 Circuit/TIP HI READ RING                  @visible:  (gJackModes[TRS2] != DISABLED)  @select: ConfigureTRS(TRS2, KEEP_MODE, TIP_HI_READ_RING);  @selected: (gCircuitTypes[TRS2] == TIP_HI_READ_RING)
/Configure TRS2/TRS2 Circuit/RING HI READ TIP                  @visible:  (gJackModes[TRS2] != DISABLED)  @select: ConfigureTRS(TRS2, KEEP_MODE, RING_HI_READ_TIP);  @selected: (gCircuitTypes[TRS2] == RING_HI_READ_TIP)
/Configure TRS2/TRS2 Tip (T2)                                  @visible: (gChannelModes[T2] != DISABLED && gCircuitTypes[TRS2] != TIP_LO_READ_RING && gCircuitTypes[TRS2] != TIP_HI_READ_RING)
/Configure TRS2/TRS2 Tip (T2)/T2 Threshold/x                   @visible: (gChannelModes[T2] == DC_TRIGGER || gChannelModes[T2] == AC_TRIGGER)   @render: RenderThreshold(T2);  @left: return AdjustThreshold(-1, T2, modifyNavigation);  @right: return AdjustThreshold(+1, T2, modifyNavigation);
/Configure TRS2/TRS2 Tip (T2)/T2 Minimum ms/x                  @visible: (gChannelModes[T2] == DC_TRIGGER || gChannelModes[T2] == AC_TRIGGER)   @render: RenderMinLength(T2);  @left: return AdjustMinLength(-1, T2, modifyNavigation);  @right: return AdjustMinLength(+1, T2, modifyNavigation);
/Configure TRS2/TRS2 Tip (T2)/T2 Increment ms/x                @visible: (gChannelModes[T2] == DC_TRIGGER || gChannelModes[T2] == AC_TRIGGER)   @render: RenderIncrement(T2);  @left: return AdjustIncrement(-1, T2, modifyNavigation);  @right: return AdjustIncrement(+1, T2, modifyNavigation);
/Configure TRS2/TRS2 Tip (T2)/T2 Refractory ms/x               @visible: (gChannelModes[T2] == DC_TRIGGER || gChannelModes[T2] == AC_TRIGGER)   @render: RenderRefractMs(T2);  @left: return AdjustRefractMs(-1, T2, modifyNavigation);  @right: return AdjustRefractMs(+1, T2, modifyNavigation);
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D0_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D0_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D0_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D1_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D1_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D1_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D2_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D2_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D2_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D3_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D3_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D3_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D4_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D4_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D4_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D5_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D5_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D5_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D6_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D6_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D6_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D7_OUT            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D7_OUT; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D7_OUT)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D8_LED            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D8_LED; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D8_LED)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/D9_LED            @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.D9_LED; InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.D9_LED)
/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/NO D-SUB PIN      @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = NO_PIN;       InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == NO_PIN      )
#/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/BNC1              @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.BNC1;   InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.BNC1  )
#/Configure TRS2/TRS2 Tip (T2)/T2 Main Output/BNC2              @visible: (gChannelModes[T2] != DISABLED)   @select: gOutput1Pins[T2] = genie.BNC2;   InitializeOutputPins(T2);  @selected: (gOutput1Pins[T2] == genie.BNC2  )
/Configure TRS2/TRS2 Ring (R2)                                 @visible: (gChannelModes[R2] != DISABLED && gCircuitTypes[TRS2] != RING_LO_READ_TIP && gCircuitTypes[TRS2] != RING_HI_READ_TIP)
/Configure TRS2/TRS2 Ring (R2)/R2 Threshold/x                  @visible: (gChannelModes[R2] == DC_TRIGGER || gChannelModes[R2] == AC_TRIGGER)   @render: RenderThreshold(R2);  @left: return AdjustThreshold(-1, R2, modifyNavigation);  @right: return AdjustThreshold(+1, R2, modifyNavigation);
/Configure TRS2/TRS2 Ring (R2)/R2 Minimum ms/x                 @visible: (gChannelModes[R2] == DC_TRIGGER || gChannelModes[R2] == AC_TRIGGER)   @render: RenderMinLength(R2);  @left: return AdjustMinLength(-1, R2, modifyNavigation);  @right: return AdjustMinLength(+1, R2, modifyNavigation);
/Configure TRS2/TRS2 Ring (R2)/R2 Increment ms/x               @visible: (gChannelModes[R2] == DC_TRIGGER || gChannelModes[R2] == AC_TRIGGER)   @render: RenderIncrement(R2);  @left: return AdjustIncrement(-1, R2, modifyNavigation);  @right: return AdjustIncrement(+1, R2, modifyNavigation);
/Configure TRS2/TRS2 Ring (R2)/R2 Refractory ms/x              @visible: (gChannelModes[R2] == DC_TRIGGER || gChannelModes[R2] == AC_TRIGGER)   @render: RenderRefractMs(R2);  @left: return AdjustRefractMs(-1, R2, modifyNavigation);  @right: return AdjustRefractMs(+1, R2, modifyNavigation);
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D0_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D0_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D0_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D1_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D1_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D1_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D2_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D2_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D2_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D3_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D3_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D3_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D4_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D4_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D4_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D5_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D5_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D5_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D6_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D6_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D6_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D7_OUT           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D7_OUT; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D7_OUT)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D8_LED           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D8_LED; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D8_LED)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/D9_LED           @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.D9_LED; InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.D9_LED)
/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/NO D-SUB PIN     @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = NO_PIN;       InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == NO_PIN      )
#/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/BNC1             @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.BNC1;   InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.BNC1  )
#/Configure TRS2/TRS2 Ring (R2)/R2 Main Output/BNC2             @visible: (gChannelModes[R2] != DISABLED)   @select: gOutput1Pins[R2] = genie.BNC2;   InitializeOutputPins(R2);  @selected: (gOutput1Pins[R2] == genie.BNC2  )

/Configure TRS3                                                @visible: (gVisibleInMenu[TRS3] && genie.BOARD_REVISION >= 3)
/Configure TRS3/TRS3 Mode/AC TRIGGER                           @select:  ConfigureTRS(TRS3, AC_TRIGGER);   @selected: (gJackModes[TRS3] == AC_TRIGGER)
/Configure TRS3/TRS3 Mode/DC TRIGGER                           @select:  ConfigureTRS(TRS3, DC_TRIGGER);   @selected: (gJackModes[TRS3] == DC_TRIGGER)
/Configure TRS3/TRS3 Mode/SWITCH                               @select:  ConfigureTRS(TRS3, SWITCH    );   @selected: (gJackModes[TRS3] == SWITCH    )
/Configure TRS3/TRS3 Mode/NO PROCESSING                        @select:  ConfigureTRS(TRS3, DISABLED  );   @selected: (gJackModes[TRS3] == DISABLED  )
#/Configure TRS3/TRS3 Sample Rate/x                             @visible   (gJackModes[TRS3] == DC_TRIGGER || gJackModes[TRS3] == AC_TRIGGER)  @left: return AdjustSampleRate(-1, TRS3, modifyNavigation); @right: return AdjustSampleRate(+1, TRS3, modifyNavigation); @render: RenderSampleRate(TRS3);
/Configure TRS3/TRS3 Circuit                                   @visible:  (gJackModes[TRS3] != DISABLED)
/Configure TRS3/TRS3 Circuit/READ TIP & RING                   @visible:  (gJackModes[TRS3] != DISABLED)  @select: ConfigureTRS(TRS3, KEEP_MODE, READ_BOTH       );  @selected: (gCircuitTypes[TRS3] == READ_BOTH       )
/Configure TRS3/TRS3 Circuit/TIP LO READ RING                  @visible:  (gJackModes[TRS3] != DISABLED)  @select: ConfigureTRS(TRS3, KEEP_MODE, TIP_LO_READ_RING);  @selected: (gCircuitTypes[TRS3] == TIP_LO_READ_RING)
/Configure TRS3/TRS3 Circuit/RING LO READ TIP                  @visible:  (gJackModes[TRS3] != DISABLED)  @select: ConfigureTRS(TRS3, KEEP_MODE, RING_LO_READ_TIP);  @selected: (gCircuitTypes[TRS3] == RING_LO_READ_TIP)
/Configure TRS3/TRS3 Circuit/TIP HI READ RING                  @visible:  (gJackModes[TRS3] != DISABLED)  @select: ConfigureTRS(TRS3, KEEP_MODE, TIP_HI_READ_RING);  @selected: (gCircuitTypes[TRS3] == TIP_HI_READ_RING)
/Configure TRS3/TRS3 Circuit/RING HI READ TIP                  @visible:  (gJackModes[TRS3] != DISABLED)  @select: ConfigureTRS(TRS3, KEEP_MODE, RING_HI_READ_TIP);  @selected: (gCircuitTypes[TRS3] == RING_HI_READ_TIP)
/Configure TRS3/TRS3 Tip (T3)                                  @visible: (gChannelModes[T3] != DISABLED && gCircuitTypes[TRS3] != TIP_LO_READ_RING && gCircuitTypes[TRS3] != TIP_HI_READ_RING)
/Configure TRS3/TRS3 Tip (T3)/T3 Threshold/x                   @visible: (gChannelModes[T3] == DC_TRIGGER || gChannelModes[T3] == AC_TRIGGER)   @render: RenderThreshold(T3);  @left: return AdjustThreshold(-1, T3, modifyNavigation);  @right: return AdjustThreshold(+1, T3, modifyNavigation);
/Configure TRS3/TRS3 Tip (T3)/T3 Minimum ms/x                  @visible: (gChannelModes[T3] == DC_TRIGGER || gChannelModes[T3] == AC_TRIGGER)   @render: RenderMinLength(T3);  @left: return AdjustMinLength(-1, T3, modifyNavigation);  @right: return AdjustMinLength(+1, T3, modifyNavigation);
/Configure TRS3/TRS3 Tip (T3)/T3 Increment ms/x                @visible: (gChannelModes[T3] == DC_TRIGGER || gChannelModes[T3] == AC_TRIGGER)   @render: RenderIncrement(T3);  @left: return AdjustIncrement(-1, T3, modifyNavigation);  @right: return AdjustIncrement(+1, T3, modifyNavigation);
/Configure TRS3/TRS3 Tip (T3)/T3 Refractory ms/x               @visible: (gChannelModes[T3] == DC_TRIGGER || gChannelModes[T3] == AC_TRIGGER)   @render: RenderRefractMs(T3);  @left: return AdjustRefractMs(-1, T3, modifyNavigation);  @right: return AdjustRefractMs(+1, T3, modifyNavigation);
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D0_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D0_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D0_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D1_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D1_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D1_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D2_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D2_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D2_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D3_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D3_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D3_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D4_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D4_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D4_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D5_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D5_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D5_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D6_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D6_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D6_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D7_OUT            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D7_OUT; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D7_OUT)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D8_LED            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D8_LED; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D8_LED)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/D9_LED            @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.D9_LED; InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.D9_LED)
/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/NO D-SUB PIN      @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = NO_PIN;       InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == NO_PIN      )
#/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/BNC1              @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.BNC1;   InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.BNC1  )
#/Configure TRS3/TRS3 Tip (T3)/T3 Main Output/BNC2              @visible: (gChannelModes[T3] != DISABLED)   @select: gOutput1Pins[T3] = genie.BNC2;   InitializeOutputPins(T3);  @selected: (gOutput1Pins[T3] == genie.BNC2  )
/Configure TRS3/TRS3 Ring (R3)                                 @visible: (gChannelModes[R3] != DISABLED && gCircuitTypes[TRS3] != RING_LO_READ_TIP && gCircuitTypes[TRS3] != RING_HI_READ_TIP)
/Configure TRS3/TRS3 Ring (R3)/R3 Threshold/x                  @visible: (gChannelModes[R3] == DC_TRIGGER || gChannelModes[R3] == AC_TRIGGER)   @render: RenderThreshold(R3);  @left: return AdjustThreshold(-1, R3, modifyNavigation);  @right: return AdjustThreshold(+1, R3, modifyNavigation);
/Configure TRS3/TRS3 Ring (R3)/R3 Minimum ms/x                 @visible: (gChannelModes[R3] == DC_TRIGGER || gChannelModes[R3] == AC_TRIGGER)   @render: RenderMinLength(R3);  @left: return AdjustMinLength(-1, R3, modifyNavigation);  @right: return AdjustMinLength(+1, R3, modifyNavigation);
/Configure TRS3/TRS3 Ring (R3)/R3 Increment ms/x               @visible: (gChannelModes[R3] == DC_TRIGGER || gChannelModes[R3] == AC_TRIGGER)   @render: RenderIncrement(R3);  @left: return AdjustIncrement(-1, R3, modifyNavigation);  @right: return AdjustIncrement(+1, R3, modifyNavigation);
/Configure TRS3/TRS3 Ring (R3)/R3 Refractory ms/x              @visible: (gChannelModes[R3] == DC_TRIGGER || gChannelModes[R3] == AC_TRIGGER)   @render: RenderRefractMs(R3);  @left: return AdjustRefractMs(-1, R3, modifyNavigation);  @right: return AdjustRefractMs(+1, R3, modifyNavigation);
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D0_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D0_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D0_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D1_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D1_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D1_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D2_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D2_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D2_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D3_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D3_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D3_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D4_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D4_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D4_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D5_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D5_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D5_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D6_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D6_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D6_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D7_OUT           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D7_OUT; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D7_OUT)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D8_LED           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D8_LED; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D8_LED)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/D9_LED           @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.D9_LED; InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.D9_LED)
/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/NO D-SUB PIN     @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = NO_PIN;       InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == NO_PIN      )
#/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/BNC1             @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.BNC1;   InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.BNC1  )
#/Configure TRS3/TRS3 Ring (R3)/R3 Main Output/BNC2             @visible: (gChannelModes[R3] != DISABLED)   @select: gOutput1Pins[R3] = genie.BNC2;   InitializeOutputPins(R3);  @selected: (gOutput1Pins[R3] == genie.BNC2  )

/Configure TRS4                                                @visible: (gVisibleInMenu[TRS4] && genie.BOARD_REVISION >= 3)
/Configure TRS4/TRS4 Mode/AC TRIGGER                           @select:  ConfigureTRS(TRS4, AC_TRIGGER);   @selected: (gJackModes[TRS4] == AC_TRIGGER)
/Configure TRS4/TRS4 Mode/DC TRIGGER                           @select:  ConfigureTRS(TRS4, DC_TRIGGER);   @selected: (gJackModes[TRS4] == DC_TRIGGER)
/Configure TRS4/TRS4 Mode/SWITCH                               @select:  ConfigureTRS(TRS4, SWITCH    );   @selected: (gJackModes[TRS4] == SWITCH    )  @visible: (genie.BOARD_REVISION == 3) /* genie rev 2 only had two TRSes, genie rev 4 introduced the bias on T4 & R4 */
/Configure TRS4/TRS4 Mode/NO PROCESSING                        @select:  ConfigureTRS(TRS4, DISABLED  );   @selected: (gJackModes[TRS4] == DISABLED  )
#/Configure TRS4/TRS4 Sample Rate/x                             @visible   (gJackModes[TRS4] == DC_TRIGGER || gJackModes[TRS4] == AC_TRIGGER)  @left: return AdjustSampleRate(-1, TRS4, modifyNavigation); @right: return AdjustSampleRate(+1, TRS4, modifyNavigation); @render: RenderSampleRate(TRS4);
/Configure TRS4/TRS4 Circuit                                   @visible:  (gJackModes[TRS4] != DISABLED)  
/Configure TRS4/TRS4 Circuit/READ TIP & RING                   @select: ConfigureTRS(TRS4, KEEP_MODE, READ_BOTH       );  @selected: (gCircuitTypes[TRS4] == READ_BOTH       )
/Configure TRS4/TRS4 Circuit/TIP LO READ RING                  @select: ConfigureTRS(TRS4, KEEP_MODE, TIP_LO_READ_RING);  @selected: (gCircuitTypes[TRS4] == TIP_LO_READ_RING)  @visible:  (gJackModes[TRS4] != DISABLED)  
/Configure TRS4/TRS4 Circuit/RING LO READ TIP                  @select: ConfigureTRS(TRS4, KEEP_MODE, RING_LO_READ_TIP);  @selected: (gCircuitTypes[TRS4] == RING_LO_READ_TIP)  @visible:  (gJackModes[TRS4] != DISABLED)  
/Configure TRS4/TRS4 Circuit/TIP HI READ RING                  @select: ConfigureTRS(TRS4, KEEP_MODE, TIP_HI_READ_RING);  @selected: (gCircuitTypes[TRS4] == TIP_HI_READ_RING)  @visible: ((gJackModes[TRS4] != DISABLED) && genie.BOARD_REVISION == 3 ) /* genie rev 2 only had two TRSes, and genie rev 4 introduced the bias on T4 & R4 (so cannot set pins high) */
/Configure TRS4/TRS4 Circuit/RING HI READ TIP                  @select: ConfigureTRS(TRS4, KEEP_MODE, RING_HI_READ_TIP);  @selected: (gCircuitTypes[TRS4] == RING_HI_READ_TIP)  @visible: ((gJackModes[TRS4] != DISABLED) && genie.BOARD_REVISION == 3 ) /* genie rev 2 only had two TRSes, and genie rev 4 introduced the bias on T4 & R4 (so cannot set pins high) */
/Configure TRS4/TRS4 Tip (T4)                                  @visible: (gChannelModes[T4] != DISABLED && gCircuitTypes[TRS4] != TIP_LO_READ_RING && gCircuitTypes[TRS4] != TIP_HI_READ_RING)
/Configure TRS4/TRS4 Tip (T4)/T4 Threshold/x                   @visible: (gChannelModes[T4] == DC_TRIGGER || gChannelModes[T4] == AC_TRIGGER)   @render: RenderThreshold(T4);  @left: return AdjustThreshold(-1, T4, modifyNavigation);  @right: return AdjustThreshold(+1, T4, modifyNavigation);
/Configure TRS4/TRS4 Tip (T4)/T4 Minimum ms/x                  @visible: (gChannelModes[T4] == DC_TRIGGER || gChannelModes[T4] == AC_TRIGGER)   @render: RenderMinLength(T4);  @left: return AdjustMinLength(-1, T4, modifyNavigation);  @right: return AdjustMinLength(+1, T4, modifyNavigation);
/Configure TRS4/TRS4 Tip (T4)/T4 Increment ms/x                @visible: (gChannelModes[T4] == DC_TRIGGER || gChannelModes[T4] == AC_TRIGGER)   @render: RenderIncrement(T4);  @left: return AdjustIncrement(-1, T4, modifyNavigation);  @right: return AdjustIncrement(+1, T4, modifyNavigation);
/Configure TRS4/TRS4 Tip (T4)/T4 Refractory ms/x               @visible: (gChannelModes[T4] == DC_TRIGGER || gChannelModes[T4] == AC_TRIGGER)   @render: RenderRefractMs(T4);  @left: return AdjustRefractMs(-1, T4, modifyNavigation);  @right: return AdjustRefractMs(+1, T4, modifyNavigation);
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D0_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D0_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D0_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D1_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D1_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D1_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D2_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D2_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D2_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D3_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D3_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D3_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D4_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D4_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D4_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D5_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D5_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D5_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D6_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D6_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D6_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D7_OUT            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D7_OUT; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D7_OUT)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D8_LED            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D8_LED; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D8_LED)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/D9_LED            @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.D9_LED; InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.D9_LED)
/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/NO D-SUB PIN      @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = NO_PIN;       InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == NO_PIN      )
#/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/BNC1              @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.BNC1;   InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.BNC1  )
#/Configure TRS4/TRS4 Tip (T4)/T4 Main Output/BNC2              @visible: (gChannelModes[T4] != DISABLED)   @select: gOutput1Pins[T4] = genie.BNC2;   InitializeOutputPins(T4);  @selected: (gOutput1Pins[T4] == genie.BNC2  )
/Configure TRS4/TRS4 Ring (R4)                                 @visible: (gChannelModes[R4] != DISABLED && gCircuitTypes[TRS4] != RING_LO_READ_TIP && gCircuitTypes[TRS4] != RING_HI_READ_TIP)
/Configure TRS4/TRS4 Ring (R4)/R4 Threshold/x                  @visible: (gChannelModes[R4] == DC_TRIGGER || gChannelModes[R4] == AC_TRIGGER)   @render: RenderThreshold(R4);  @left: return AdjustThreshold(-1, R4, modifyNavigation);  @right: return AdjustThreshold(+1, R4, modifyNavigation);
/Configure TRS4/TRS4 Ring (R4)/R4 Minimum ms/x                 @visible: (gChannelModes[R4] == DC_TRIGGER || gChannelModes[R4] == AC_TRIGGER)   @render: RenderMinLength(R4);  @left: return AdjustMinLength(-1, R4, modifyNavigation);  @right: return AdjustMinLength(+1, R4, modifyNavigation);
/Configure TRS4/TRS4 Ring (R4)/R4 Increment ms/x               @visible: (gChannelModes[R4] == DC_TRIGGER || gChannelModes[R4] == AC_TRIGGER)   @render: RenderIncrement(R4);  @left: return AdjustIncrement(-1, R4, modifyNavigation);  @right: return AdjustIncrement(+1, R4, modifyNavigation);
/Configure TRS4/TRS4 Ring (R4)/R4 Refractory ms/x              @visible: (gChannelModes[R4] == DC_TRIGGER || gChannelModes[R4] == AC_TRIGGER)   @render: RenderRefractMs(R4);  @left: return AdjustRefractMs(-1, R4, modifyNavigation);  @right: return AdjustRefractMs(+1, R4, modifyNavigation);
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D0_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D0_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D0_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D1_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D1_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D1_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D2_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D2_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D2_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D3_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D3_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D3_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D4_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D4_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D4_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D5_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D5_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D5_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D6_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D6_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D6_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D7_OUT           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D7_OUT; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D7_OUT)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D8_LED           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D8_LED; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D8_LED)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/D9_LED           @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.D9_LED; InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.D9_LED)
/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/NO D-SUB PIN     @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = NO_PIN;       InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == NO_PIN      )
#/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/BNC1             @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.BNC1;   InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.BNC1  )
#/Configure TRS4/TRS4 Ring (R4)/R4 Main Output/BNC2             @visible: (gChannelModes[R4] != DISABLED)   @select: gOutput1Pins[R4] = genie.BNC2;   InitializeOutputPins(R4);  @selected: (gOutput1Pins[R4] == genie.BNC2  )

/Secondary Output/Mirror to BNC1/UNASSIGNED                    @visible:                                                             @select: AssignBNC(genie.BNC1, NO_CHANNEL);  @selected: (FindBNC(genie.BNC1) == NO_CHANNEL)
/Secondary Output/Mirror to BNC1/TRS1 TIP (T1)                 @visible: (gVisibleInMenu[TRS1] && AvailableForBNC(genie.BNC1, T1))   @select: AssignBNC(genie.BNC1, T1);          @selected: (FindBNC(genie.BNC1) == T1)
/Secondary Output/Mirror to BNC1/TRS1 RING (R1)                @visible: (gVisibleInMenu[TRS1] && AvailableForBNC(genie.BNC1, R1))   @select: AssignBNC(genie.BNC1, R1);          @selected: (FindBNC(genie.BNC1) == R1)
/Secondary Output/Mirror to BNC1/TRS2 TIP (T2)                 @visible: (gVisibleInMenu[TRS2] && AvailableForBNC(genie.BNC1, T2))   @select: AssignBNC(genie.BNC1, T2);          @selected: (FindBNC(genie.BNC1) == T2)
/Secondary Output/Mirror to BNC1/TRS2 RING (R2)                @visible: (gVisibleInMenu[TRS2] && AvailableForBNC(genie.BNC1, R2))   @select: AssignBNC(genie.BNC1, R2);          @selected: (FindBNC(genie.BNC1) == R2)
/Secondary Output/Mirror to BNC1/TRS3 TIP (T3)                 @visible: (gVisibleInMenu[TRS3] && AvailableForBNC(genie.BNC1, T3))   @select: AssignBNC(genie.BNC1, T3);          @selected: (FindBNC(genie.BNC1) == T3)
/Secondary Output/Mirror to BNC1/TRS3 RING (R3)                @visible: (gVisibleInMenu[TRS3] && AvailableForBNC(genie.BNC1, R3))   @select: AssignBNC(genie.BNC1, R3);          @selected: (FindBNC(genie.BNC1) == R3)
/Secondary Output/Mirror to BNC1/TRS4 TIP (T4)                 @visible: (gVisibleInMenu[TRS4] && AvailableForBNC(genie.BNC1, T4))   @select: AssignBNC(genie.BNC1, T4);          @selected: (FindBNC(genie.BNC1) == T4)
/Secondary Output/Mirror to BNC1/TRS4 RING (R4)                @visible: (gVisibleInMenu[TRS4] && AvailableForBNC(genie.BNC1, R4))   @select: AssignBNC(genie.BNC1, R4);          @selected: (FindBNC(genie.BNC1) == R4)
/Secondary Output/Mirror to BNC2/UNASSIGNED                    @visible:                                                             @select: AssignBNC(genie.BNC2, NO_CHANNEL);  @selected: (FindBNC(genie.BNC2) == NO_CHANNEL)
/Secondary Output/Mirror to BNC2/TRS1 TIP (T1)                 @visible: (gVisibleInMenu[TRS1] && AvailableForBNC(genie.BNC2, T1))   @select: AssignBNC(genie.BNC2, T1);          @selected: (FindBNC(genie.BNC2) == T1)
/Secondary Output/Mirror to BNC2/TRS1 RING (R1)                @visible: (gVisibleInMenu[TRS1] && AvailableForBNC(genie.BNC2, R1))   @select: AssignBNC(genie.BNC2, R1);          @selected: (FindBNC(genie.BNC2) == R1)
/Secondary Output/Mirror to BNC2/TRS2 TIP (T2)                 @visible: (gVisibleInMenu[TRS2] && AvailableForBNC(genie.BNC2, T2))   @select: AssignBNC(genie.BNC2, T2);          @selected: (FindBNC(genie.BNC2) == T2)
/Secondary Output/Mirror to BNC2/TRS2 RING (R2)                @visible: (gVisibleInMenu[TRS2] && AvailableForBNC(genie.BNC2, R2))   @select: AssignBNC(genie.BNC2, R2);          @selected: (FindBNC(genie.BNC2) == R2)
/Secondary Output/Mirror to BNC2/TRS3 TIP (T3)                 @visible: (gVisibleInMenu[TRS3] && AvailableForBNC(genie.BNC2, T3))   @select: AssignBNC(genie.BNC2, T3);          @selected: (FindBNC(genie.BNC2) == T3)
/Secondary Output/Mirror to BNC2/TRS3 RING (R3)                @visible: (gVisibleInMenu[TRS3] && AvailableForBNC(genie.BNC2, R3))   @select: AssignBNC(genie.BNC2, R3);          @selected: (FindBNC(genie.BNC2) == R3)
/Secondary Output/Mirror to BNC2/TRS4 TIP (T4)                 @visible: (gVisibleInMenu[TRS4] && AvailableForBNC(genie.BNC2, T4))   @select: AssignBNC(genie.BNC2, T4);          @selected: (FindBNC(genie.BNC2) == T4)
/Secondary Output/Mirror to BNC2/TRS4 RING (R4)                @visible: (gVisibleInMenu[TRS4] && AvailableForBNC(genie.BNC2, R4))   @select: AssignBNC(genie.BNC2, R4);          @selected: (FindBNC(genie.BNC2) == R4)

/Sample Rate/x                                                 @left: return AdjustSampleRate(-1, ALL_JACKS, modifyNavigation); @right: return AdjustSampleRate(+1, ALL_JACKS, modifyNavigation); @render: RenderSampleRate(); @visible: (gJackModes[TRS1] == AC_TRIGGER || gJackModes[TRS1] == DC_TRIGGER || gJackModes[TRS2] == AC_TRIGGER || gJackModes[TRS2] == DC_TRIGGER || gJackModes[TRS3] == AC_TRIGGER || gJackModes[TRS3] == DC_TRIGGER || gJackModes[TRS4] == AC_TRIGGER || gJackModes[TRS4] == DC_TRIGGER)

/Diagnostics/Idle-Loop Count/is off - TURN ON                  @visible: (!gMeasureIdleLoops)  @select: gMeasureIdleLoops = true;  genie.bar(0);
/Diagnostics/Idle-Loop Count/is on - TURN OFF                  @visible: ( gMeasureIdleLoops)  @select: gMeasureIdleLoops = false; genie.bar(0);
/Diagnostics/Idle-Loop Count/Loops Per Bar/x                   @left: return AdjustLoopsPerBar(-1, modifyNavigation); @right: return AdjustLoopsPerBar(+1, modifyNavigation); @render: RenderLoopsPerBar();
/Diagnostics/Idle-Loop Count/Explanation                       @select: genie.loadMessage(IDLE_LOOP_DOC); return false;
/Diagnostics/Idle-Loop Count/Explanation/x                     @render: genie.showMessage();  @left: genie.scrollMessage(-1); return false;  @right: genie.scrollMessage(+1); return true;  @select: return true;
#/Diagnostics/System Info/x                                     @render: genie.display("Teensy @TEENSY_VERSION@ @TEENSY_LENGTH@", 1); 
#/Diagnostics/System Info/y                                     @render: genie.display("Genie Rev @BOARD_REVISION@", 1);              
/Diagnostics/System Info                                       @select: genie.loadMessage(INTROSPECTION); return false;
/Diagnostics/System Info/x                                     @render: genie.showMessage();  @left: genie.scrollMessage(-1); return false;  @right: genie.scrollMessage(+1); return true;  @select: return true;
/Diagnostics/Temperature                                       @visible: strncmp( TEENSY_VERSION, "3", 1 ) /* only implemented for Teensy 4+ */
/Diagnostics/Temperature/x                                     @render: RenderTemperature(); @left: return RenderTemperature(modifyNavigation); @right: return RenderTemperature(modifyNavigation);

/Serial Output/is off - TURN ON                                @visible: (!gUseSerialTriggerOutput)  @select: ConfigureSerialTriggerOutput(true);
/Serial Output/is on - TURN OFF                                @visible: ( gUseSerialTriggerOutput)  @select: ConfigureSerialTriggerOutput(false);
/Serial Output/Explanation                                     @select: genie.loadMessage(SERIAL_TRIGGER_DOC); return false;
/Serial Output/Explanation/x                                   @render: genie.showMessage();  @left: genie.scrollMessage(-1); return false;  @right: genie.scrollMessage(+1); return true;  @select: return true;

/Stored Settings/SAVE NOW                                      @select: Settings(SAVE_SETTINGS);
/Stored Settings/REVERT TO SAVED                               @select: Settings(LOAD_SETTINGS);
